<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
 
jimport( 'joomla.application.component.model' );


class JoomdModelConfig extends JModel
{
    
    var $_total = null;
	var $_pagination = null;
	
	function __construct()
	{
		parent::__construct();

	}
	
	function getConfig()
	{
	
		$query = 'select * from #__joomd_config';
		$this->_db->setQuery( $query );
		$config = $this->_db->loadObject();
		
		return $config;
		
	}
	
	function getPanels()
	{
		
		$items = Joomd::getPlugins();
		
		$data = array();
		
		for($i=0;$i<count($items);$i++)	{
			
			if(is_file(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php'))	{
				
				$class = "plg_".$items[$i]->view;
				
				if(!class_exists($class))
					require_once(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php');
								
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'config_display'))	{
						
						$items[$i]->html = $class->config_display();
						$data[] = $items[$i];
						
					}
				
				}
				
			}
			
		}
		
		return $data;
	
	}
	
	function store()
	{
		
		// Check for request forgeries
		JRequest::checkToken() or jexit( JText::_('INVALIDTOKEN') );
		
		$obj->error = '';
		$obj->result = 'error';
		
		$post = JRequest::get('post');
		
		$post['jquery']		= isset($post['jquery'])?1:0;
		$post['jqueryui']	= isset($post['jqueryui'])?1:0;
		$post['scroll']		= isset($post['scroll'])?1:0;
		$post['captcha']	= isset($post['captcha'])?1:0;
		$post['email']		= str_replace(' ', '', $post['email']);
		
		$emails = empty($post['email'])?array():explode(',', $post['email']);
		
		foreach($emails as $email)	{
			
			if(!preg_match("/^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]+\.)+[a-zA-Z]{2,6}$/i", $email))	{
				$obj->error = JText::_('PLSSENTVLIDEM');
				return $obj;
			}
		}
		
		$post['email'] = implode(',', $emails);
		
		$query = 'update #__joomd_config set template = '.(int)$post['template'].', scroll = '.$post['scroll'].', captcha = '.$post['captcha'].', email = "'.$post['email'].'", thumb_width = '.(int)$post['thumb_width'].', thumb_height = '.(int)$post['thumb_height'];
		$this->_db->setQuery( $query );
		
		if(!$this->_db->query())
			$obj->error = $this->_db->getErrorMsg();
			
		elseif(!$this->saveconfig($post))
			$obj->error = $this->getError();
		
		else	{
			
			$obj->msg = JText::_('SAVECONFIG');
			$obj->result = 'success';
			
		}
		
		return $obj;
		
	}
	
	function saveconfig($post)	{
		
		$items = Joomd::getPlugins();
				
		for($i=0;$i<count($items);$i++)	{
			
			if(is_file(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php'))	{
				
				$class = "plg_".$items[$i]->view;
				
				if(!class_exists($class))
					require_once(JPATH_COMPONENT.DS.'classes'.DS.'plg_'.$items[$i]->view.'.php');
				
				if(class_exists($class))	{
				
					$class = new $class;
					
					if(method_exists($class, 'config_save'))	{
						
						if(!$class->config_save($post, $this))
							return false;
						
					}
				
				}
				
			}
			
		}
		
		return true;
		
	}
	
	function getThemes()
	{
		
		$this->scanthemes();
		
		$query = 'select * from #__joomd_templates order by name asc';
		$this->_db->setQuery( $query );
		$items = $this->_db->loadObjectList();
		
		return $items;
		
	}
	
	function scanthemes()
	{
		
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');
		
		$dir = JPATH_SITE.DS.'components'.DS.'com_joomd'.DS.'templates';
		
		$query = 'select name from #__joomd_templates where id <> 1 order by name asc';
		$this->_db->setQuery( $query );
		$excludes = (array)$this->_db->loadResultArray();
		
		$themes = Jfolder::folders($dir, '.', false, false, $excludes);
		
		if(count($themes))	{
			
			for($i=0;$i<count($themes);$i++)	{
				
				if(!empty($themes[$i]))	{
					$query = 'insert into #__joomd_templates (name) values ('.$this->_db->Quote($themes[$i]).')';
					$this->_db->setQuery( $query );
					
					if(!$this->_db->query())	{
						$this->setError($this->_db->getErrorMsg());
						return false;
					}
				}
				
			}
																											
		}
		
		foreach($excludes as $t)	{
			
			if(!Jfolder::exists($dir.DS.$t))	{
				$query = 'delete from #__joomd_templates where name = '.$this->_db->Quote($t);
				$this->_db->setQuery( $query );
				
				if(!$this->_db->query())	{
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
			
		}
		
		return true;
		
	}

}

?>