<?php

/*------------------------------------------------------------------------
# com_joomd - JoomD
# ------------------------------------------------------------------------
# author    Danish Babu - Joomla6Teen Inc
# copyright Copyright (C) 2011 joomla6teen.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomla6teen.com
# Technical Support:  Forum - http://www.joomla6teen.com/index.php?option=com_ccboard&view=forumlist&Itemid=63
-----------------------------------------------------------------------*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class JoomdControllerEntry extends JoomdController
{
	
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		
		$this->config = Joomd::getConfig('entry');
		$this->user =& Joomd::getUser();
		
		require_once(JPATH_COMPONENT.'/libraries/classes/fields.php');
		
		$this->checkAccess();
		
		$this->field = new JoomdFields('entry');
		
		$this->field->checkType();
		
		$this->registerTask( 'add',	'edit' );
		$this->registerTask( 'apply',	'save' );
		
	}
	
	//to check the access level of individual entry/in configuration/by type/by category
	function checkAccess()
	{
		
		$layout = JRequest::getCmd('layout', '');
		
		$model = $this->getModel('entry');
		
		if($layout == 'detail')	{
			$item = $model->getItem();
			JRequest::setVar('typeid', $item->typeid);
			
			//to check the access level of entry
			if(!Joomd::CanAccessItem($item))
				Joomd::redirect('index.php', JText::_('AUTH_NOACCESS'));
		
		/*  removed as not good while displaying the entry list without category selection and in search
			if(!$model->checkCategoryAccess())	{
				Joomd::redirect('index.php', JText::_('AUTH_NOACCESS'));
			}
		*/	
		
		}
		
		//to check the assigned type and it's access level
		$this->_type = Joomd::getType();
		
		$catid = JRequest::getInt('catid', 0);
		$category = $model->getCategory();
		
		//check category if its exists
		if(empty($category) and $catid)	{
			Joomd::redirect(JRoute::_('index.php?option=com_joomd'), JText::_('CATEGORYNOTFOUND'));			
		}
		elseif($catid)	{
			
			if(!Joomd::CanAccessItem($category))
				Joomd::redirect('index.php', JText::_('AUTH_NOACCESS'));
			
		}
		
		//can access the list layout set in configuration
		if($this->config->list == 1 and $this->user->get('guest'))	{
			Joomd::redirect(JRoute::_('index.php?option='.COM_USER.'&view=login&return='.base64_encode(JRoute::_('index.php?option=com_joomd&view=entry&typeid='.$this->_type->id))), JText::_('Please login to access this location'));
			return;
		}
		
		//can access the detail layout set in configuration
		if($this->config->detail == 1 and $this->user->get('guest') and $layout == "detail")	{
			Joomd::redirect(JRoute::_('index.php?option='.COM_USER.'&view=login&return='.base64_encode(JRoute::_('index.php?option=com_joomd&view=entry&typeid='.$this->_type->id))), JText::_('Please login to access this location'));
			return;
		}
		
	}	
	
	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		
		if($this->config->registration && $this->user->get('guest'))
			jexit(JText::_('Unauthorized Access'));
		
		JRequest::setVar( 'view', 'entrypanel'  );
		JRequest::setVar( 'layout', 'form'  );
		
		$html = parent::edit();
		
		jexit($html);
		
	}
	
	function getItems()
	{
		
		$config = Joomd::getConfig();
		$model = $this->getModel('entry');
		
		$layout = JRequest::getCmd('layout', 'default');
		
		$params = $model->getParams();
		
		$this->items = $model->getItems();
		$this->fields =& $this->field->getFields(array('cats'=>$params->catid, 'published'=>1, 'list'=>true, 'access'=>true));
		
		ob_start();
		$n = $params->limitstart;
		for($i=0;$i<count($this->items);$i++)	{
		
			$item =& $this->items[$i];
			
			$class = $n%2?'entry_row':'entry_row_bg';
			
			echo '<div class="'.$class.'">';
			
			$path = Joomd::getTemplatePath('entry', $layout.'_item.php');
			
			require($path);
			
			echo '<div class="clr"></div></div>';
			$n++;
		}
		
		$html = ob_get_contents();
		
		ob_end_clean();
		
		$data->html = $html;
		$data->count = count($this->items);
		$data->total = $params->total;
		
		return $data;
		
	}
	
	function loaditems()
	{
		
		$data = $this->getItems();
		
		$json->result = "success";
		$json->html = $data->html;
		$json->count = $data->count;
		$json->total = $data->total;
		
		jexit(json_encode($json));
	
	}
	
	function loaditem($item, $fields)
	{
		
		$model = $this->getModel('entry');
		
		$this->item = $item;
		$this->fields = $fields;
		
		$firstfield = $this->field->get_firstfield(array('published'=>1));
		
		$html = '';
		
		if(!Joomd::CanAccessItem($item))
			return $html;
	/*			
		if(!$model->checkCategoryAccess($item->id))
			return $html;
	*/	
		
		if($firstfield->type == 1)	{
			$html .= '<div class="componentheading"><h1>'.$this->field->displayfieldvalue($this->item->id, $firstfield->id).'</h1></div>';
		}
		
		for($i=0;$i<count($this->fields);$i++)	{
		
			$value = $this->field->getfieldvalue($this->item->id, $this->fields[$i]->id);
			
			if(!($i==0 and $this->fields[$i]->type == 1) and !empty($value))	{
			
				$html .= '<div class="field_block '.$this->fields[$i]->cssclass.'">';
				
				$html .= '<div class="field_label">';
				
				if($this->fields[$i]->showtitle)
					$html .= $this->fields[$i]->name;
				
				if($this->fields[$i]->showicon && !empty($this->fields[$i]->icon) && is_file(JPATH_SITE.'/images/joomd/'.$this->fields[$i]->icon))
					$html .= '&nbsp;<img src="images/joomd/'.$this->fields[$i]->icon.'" alt="'.$this->fields[$i]->name.'" style="max-height:16px;" align="absbottom" />';
				
				$html .= '</div>';
				
				$html .= $this->field->displayfieldvalue($this->item->id, $this->fields[$i]->id);
				
				$html .= '</div><br />';
			
			}
		
		}
		
		return $html;
		
	}
	
	function printall()
	{
		
		$model = $this->getModel('entry');
		
		$items =& $model->getItems();
		
		$obj->html = '<a href="javascript:void(0);" onclick="$jd(\'#joomdprint\').printElement();" class="printicon"><span>print</span></a><div id="joomdprint">';
		
		for($i=0;$i<count($items);$i++)	{
			
			//get fields to generate the pdf/print
			$fields =& $this->field->getFields(array('itemid'=>$items[$i]->id, 'published'=>1, 'detail'=>true, 'type'=>array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)));
			
			$obj->html .= '<div class="entry_row">'.$this->loaditem($items[$i], $fields).'</div>';
			
		}
		
		$obj->html .= '</div>';
		
		$obj->result = 'success';
		
		jexit(json_encode($obj));
		
	}
	
	function printone()
	{
				
		$model = $this->getModel('entry');		
		$item = $model->getItem();
		
		$obj->html = '<a href="javascript:void(0);" onclick="$jd(\'#joomdprint\').printElement();" class="printicon"><span>print</span></a><div id="joomdprint">';
		
		//get fields to generate the pdf/print
		$fields =& $this->field->getFields(array('itemid'=>$item->id, 'published'=>1, 'detail'=>true, 'type'=>array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)));
		
		$obj->html .= $this->loaditem($item, $fields);
		
		$obj->html .= '</div>';
		
		$obj->result = 'success';
		
		jexit(json_encode($obj));
		
	}
	
		
	function pdfall()
	{
		
		$model = $this->getModel('entry');
		
		$items =& $model->getItems();
		
		$obj->html = '<div id="joomdprint">';
		
		for($i=0;$i<count($items);$i++)	{
			
			//get fields to generate the pdf/print
			$fields =& $this->field->getFields(array('itemid'=>$items[$i]->id, 'published'=>1, 'detail'=>true, 'type'=>array(1, 2, 3, 4, 5, 6, 7, 8, 9)));
			
			$obj->html .= $this->loaditem($items[$i], $fields).'<br />';
			
		}
		
		$obj->html .= '</div>';
		
		echo $obj->html;
		
	}
	
	function pdfone()
	{
				
		$model = $this->getModel('entry');		
		$item = $model->getItem();
		
		$obj->html = '<div id="joomdprint">';
		
		//get fields to generate the pdf/print
		$fields =& $this->field->getFields(array('itemid'=>$item->id, 'published'=>1, 'detail'=>true, 'type'=>array(1, 2, 3, 4, 5, 6, 7, 8, 9)));
		
		$obj->html .= $this->loaditem($item, $fields);
		
		$obj->html .= '</div>';
		
		echo $obj->html;		
		
	}
	
	function openemail()
	{
		
		$user =& JFactory::getUser();

		$url = JURI::root().'index.php?option=com_joomd&view=entry';
		
		$layout=JRequest::getVar('layout', '');
		$catid=JRequest::getInt('catid', 0);
		$id=JRequest::getInt('id', 0);
		
		if($layout=='detail')
			$url .= '&layout=detail&id='.$id;
		elseif($catid)
			$url .= '&catid='.$catid;
		
		ob_start();
		
	?>
			<script type="text/javascript">

			function submitbutton() {
								
	    		var form = document.mailtoForm;
				var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;

				// do field validation
				if (form.mailto.value == "") {
					alert( "<?php echo JText::_('Please enter reciever\'s Email address.'); ?>" );
					return false;
				}
				
				if(reg.test(form.mailto.value) == false) {
					alert( "<?php echo JText::_('Reciever\'s Email address is not valid.'); ?>" );
					return false;
				}
				if(form.from.value == "")	{
					alert( '<?php echo JText::_('Please enter your Email address'); ?>' );
					return false;
				}
				if(reg.test(form.from.value) == false) {
					alert( '<?php echo JText::_('Your Email address is not valid.'); ?>' );
					return false;
				}
								
				$jd.ajax({
                      url: "<?php echo JURI::root(); ?>index.php",
                      type: "POST",
                      dataType:"json",
                      data: {'option':'com_joomd', 'view':'entry', 'task':'sendemail', 'url':'<?php echo JRoute::_($url); ?>', 'mailto':$jd('input[name="mailto"]').val(), 'sender':$jd('input[name="sender"]').val(), 'from':$jd('input[name="from"]').val(), 'subject':$jd('input[name="subject"]').val() },
                      beforeSend: function()	{
                        $jd(".loadingblock").show();
                      },
                      complete: function()	{
                        $jd(".loadingblock").hide();
                      },
                      success: function(res)	{
                        
						$jd(".dialogbox").dialog('close');
						
                      	if(res.result == "success")	{
							displayalert(res.msg, "message");
						}
						else	{
							displayalert(res.error, "error");
						}
                            
                      },
					  error: function(jqXHR, textStatus, errorThrown)	{
						$jd('.dialogbox').dialog('close');
                        displayalert(textStatus, "error");
                      }
                });
				
				return false;
				
			}

			</script>

<form action="<?php echo JRoute::_('index.php?option=com_joomd&view=entry'); ?>" name="mailtoForm" method="post">

	<div class="componentheading"><?php echo JText::_('E-mail this link to a friend.'); ?></div>

	<p>
		<?php echo JText::_('E-mail to'); ?>:
		<br />

		<input type="text" name="mailto" class="inputbox" size="25" value=""/>
	</p>

	<p>
		<?php echo JText::_('Your Name'); ?>:
		<br />
		<input type="text" name="sender" class="inputbox" value="<?php echo $user->name; ?>" size="25" />
	</p>

	<p>

		<?php echo JText::_('Your E-mail'); ?>:
		<br />
		<input type="text" name="from" class="inputbox" value="<?php echo $user->email; ?>" size="25" />
	</p>

	<p>
		<?php echo JText::_('Subject'); ?>:
		<br />
		<input type="text" name="subject" class="inputbox" value="" size="25" />
	</p>

	<p>
		<button class="button" onClick="return submitbutton('send');">
			<?php echo JText::_('Send'); ?>		</button>
	</p>

</form>


<?php

	$data = ob_get_contents();
	
	ob_clean();
	
	$obj->result = 'success';
	$obj->html = $data;

	jexit(json_encode($obj));
	
	}

	function sendemail()
	{
		
		$to = JRequest::getVar('mailto');
		$sender = JRequest::getVar('sender');
		$from = JRequest::getVar('from');
		$subject = JRequest::getVar('subject');
		$url = JRequest::getVar('url', '', 'post', 'string');
	
		$mainframe =& JFactory::getApplication();
		
		$SiteName	= $mainframe->getCfg('sitename');
		$mail =& JFactory::getMailer();
		
		$mail->isHTML(true);
		
		$mail->addRecipient($to);
		$mail->setSubject($SiteName.'::'.$subject);
		
		$body = '<p>'.JText::sprintf('%s has sent you a link to view', $sender).':</p><p>'.$url.'</p>';
		
		$mail->setBody($body);
		$sender = array( $from, $sender );
		$mail->setSender($sender);
		$sent = $mail->send();
		
		if(is_object($sent))
			jexit('{"result":"error", "error":"'.JText::_('Sorry, Your mail could not be sent.').'"}');
		else
			jexit('{"result":"success", "msg":"'.JText::_('Your mail is sent successfully.').'"}');
		
	}

}